<?php
// Настройки сайта
include_once($_SERVER["DOCUMENT_ROOT"]."/inc/define.php");
// IP посетителя
$ipgo = isset($_COOKIE['ip_go']) ? $_COOKIE['ip_go'] : $_SERVER['REMOTE_ADDR'];
if (empty($_COOKIE['ip_go'])) setcookie('ip_go', $_SERVER['REMOTE_ADDR'], time() + 3600 * 24);
// Определение реального браузера
$ua = isset($_SERVER['HTTP_X_OPERAMINI_PHONE_UA']) ? $_SERVER['HTTP_X_OPERAMINI_PHONE_UA'] : $_SERVER['HTTP_USER_AGENT'];
// Подключение к БД
try {
$connect = new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME.";charset=utf8", DB_USER, DB_PASS);
} catch (PDOException $e) {
die("Подключение не удалось: ".$e->getMessage());
}
// Корневая папка
define('ROOT', 'http://'.$_SERVER['HTTP_HOST']);
// Кодировка
iconv_set_encoding('internal_encoding', 'UTF-8');
// Дата и время
date_default_timezone_set('Europe/Moscow');
// Фильтр всех входящих данных
if (isset($_POST)) foreach ($_POST as $key => $value) $_POST[$key] = trim(stripslashes(htmlspecialchars($value, ENT_QUOTES)));
if (isset($_GET)) foreach ($_GET as $key => $value) $_GET[$key] = trim(stripslashes(htmlspecialchars($value, ENT_QUOTES)));
if (isset($_SESSION)) foreach ($_SESSION as $key => $value) $_SESSION[$key] = trim(stripslashes(htmlspecialchars($value, ENT_QUOTES)));
if (isset($_COOKIE)) foreach ($_COOKIE as $key => $value) $_COOKIE[$key] = trim(stripslashes(htmlspecialchars($value, ENT_QUOTES)));
// Функция фильтровки чисел
function val($str, $abs = null) {
if ($abs == null) {
return intval($str);
} else {
return abs(intval($str));
}
}
// Вес файла
function get_filesize($file) {
if(!file_exists($file)) return "Файл не найден";
$filesize = filesize($file);
if($filesize > 1024){
$filesize = ($filesize/1024);
if($filesize > 1024){
$filesize = ($filesize/1024);
if($filesize > 1024) {
$filesize = ($filesize/1024);
$filesize = round($filesize, 1);
return $filesize." Gb";
} else {
$filesize = round($filesize, 1);
return $filesize." Mb";
}
} else {
$filesize = round($filesize, 1);
return $filesize." Kb";
}
} else {
$filesize = round($filesize, 1);
return $filesize." byte";
}
}
// Удаление файлов из папки
function delete_file_dir($dir) {
$scan = scandir($dir);
foreach ($scan as $file) {
unlink($dir."/".$file);
}
}
// Функция ББ кодов
function bb($str) {
// Жирный шрифт
$str = preg_replace('#\[b\](.*?)\[/b\]#si', '<b>\1</b>', $str);
// Наклоненный шрифт
$str = preg_replace('#\[i\](.*?)\[/i\]#si', '<i>\1</i>', $str);
// Подчеркнутый шрифт
$str = preg_replace('#\[u\](.*?)\[/u\]#si', '<u>\1</u>', $str);
// Перенос текста
$str = preg_replace('#\[br\]#si', '<br/>', $str);
// Зачеркнутый шрифт
$str = preg_replace('#\[del\](.*?)\[/del\]#si', '<del>\1</del>', $str);
// Маленький шрифт
$str = preg_replace('#\[small\](.*?)\[/small\]#si', '<small>\1</small>', $str);
// Цветной шрифт
$str = preg_replace('#\[color=(.*?)\](.*?)\[/color\]#si', '<span style="color:\1">\2</span>', $str);
// Мигающий текст
$str = preg_replace('#\[blink\](.*?)\[/blink\]#si', '<div id="blink2">\1</div>', $str);
// Цитата
$str = preg_replace('#\[cit\](.*?)\[/cit\]#si', '<div class="cit">\1</div>', $str);
return $str;
}
// Ссылки
function url_replace($m) {
if (!isset($m[3])) {
return '<a href="'.$m[1]. '">'.$m[2].'</a>';
} else {
return '<a href="'.$m[3].'">'.$m[3].'</a>';
}
}
function bblinks($link) {
$link = preg_replace_callback('~\\[url=(http://.+?)\\](.+?)\\[/url\\]|(http://(www.)?[0-9a-z\.\-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\-\~&;_=%:#\+]*)~', 'url_replace', $link);
return $link;
}
// Функция вывода смайлов
function smiles($str) {
global $user;
for($i = 1; $i <= count(glob($_SERVER["DOCUMENT_ROOT"]."/img/smiles/*.gif")); $i++) {
$str = str_replace(':'.$i.':', '<img src="/img/smiles/'.$i.'.gif" alt=""/>', $str);
} 
return $str;
}
// Обработка времени
function daytime($var) {
if ($var == NULL) $var = time();
$full_time = date('d.m.Y в H:i', $var);
$date = date('d.m.Y', $var);
$time = date('H:i', $var);
if ($date == date('d.m.Y')) $full_time = date('Сегодня в H:i', $var);
if ($date == date('d.m.Y', time()-60*60*24)) $full_time = date('Вчера в H:i', $var);
return $full_time;
}
// Функция отправки почты на email
function mailto($mail, $theme, $text, $str) {
$utf = "From: ".$str." \n";
$utf.= "X-sender: < ".$str." >\n";
$utf.= "Content-Type: text/html; charset=utf-8\n";
return mail($mail, $theme, $text, $utf);
}
// Функция генерации пароля
function gen_pass($col = 8) {
$row = 'abcdefghijklmnopqrstuvwxvzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
$str = '';
for($i= 0 ; $i < $col; $i++) {
$str.= $row[rand(0, 61)];
}
return $str;
}
// Функции извлечения настроек с базы
$systema = $connect->query("SELECT * FROM `settings`")->fetchAll();
$set = array();
foreach ($systema as $query) {
$set[$query[0]] = $query[1];
}
// Статус онлайн
function online($user, $connect){
$result = $connect->prepare("SELECT * FROM `users` WHERE `login` = ?");
$result->execute(array($user));
$row = $result->fetch(PDO::FETCH_LAZY);
if ($row['lasttime'] < time() - 900) {
$online = "";
} else {
$online = "on";
}
return $online;
}
// Функция авторизации
if (isset($_COOKIE['login']) && isset($_COOKIE['pass'])) {
$sql = $connect->prepare("select * from `users` where `login` = ?");
$sql->execute(array($_COOKIE['login']));
$num = $sql->rowCount();
if ($num > 0) {
$user = $sql->fetch(PDO::FETCH_LAZY);
if ($user['login'] == strtolower($_COOKIE['login']) or strtoupper($_COOKIE['login']) && $user['pass'] == $_COOKIE['pass']) {
$active = true;
// Онлайн
$stmt = $connect->prepare("update `users` set `lasttime` = ? where `id` = ? limit 1");
$stmt->execute(array(time(), $user['id']));
} else {
SetCookie('login', '', time() - 3600, '/');
SetCookie('pass', '', time() - 3600, '/');
session_destroy();
}
} else {
SetCookie('login', '', time() - 3600, '/');
SetCookie('pass', '', time() - 3600, '/');
session_destroy();
}
}
// Функции постраничной навигации
function page($k_page = 1) {
$page = 1;
if (isset($_GET['page'])) {
if ($_GET['page'] == 'end') {
$page = intval($k_page);
}
elseif(is_numeric($_GET['page'])) {
$page = intval($_GET['page']);
}
if ($page < 1) {
$page = 1;
}
if ($page > $k_page) {
$page = $k_page;
}
}
return $page;
}
function k_page($k_post = 0, $k_p_str = 10) {
if ($k_post != 0) {
$v_pages = ceil($k_post / $k_p_str);
return $v_pages;
} else {
return 1;
}
}
function navigation($k_page = 1, $page = 1, $link = '?') {
if ($page < 1) {
$page = 1;
}
echo '<div class="menu">';
if ($page != 1) {
echo '<span class="page_ot"><a href="'.$link.'page=1">1</a></span>';
} else {
echo '<span class="page">1</span>';
}
for ($i =- 3; $i <= 3; $i++) {
if ($page + $i > 1 && $page + $i < $k_page) {
if ($i ==- 3 && $page + $i > 2) {
echo '<span class="page">...</span>';
}
if ($i != 0) {
echo '<span class="page_ot"><a href="'.$link.'page='.($page + $i).'">'.($page + $i).'</a></span>';
} else {
echo '<span class="page">'.($page + $i).'</span>';
}
if ($i == 3 && $page + $i < $k_page - 1) {
echo '<span class="page">...</span>';
}
}
}
if ($page != $k_page) {
echo '<span class="page_zh"><a href="'.$link.'page=end">'.$k_page.'</a></span>';
}
elseif ($k_page > 1) {
echo '<span class="page">'.$k_page.'</span>';
}
echo '</div>';
}
// Узнаем id по логину
function uid($str, $connect) {
$sql = $connect->prepare("select * from `users` where `login` = ?");
$sql->execute(array($str));
$num = $sql->rowCount();
if ($num  == 0) {
return false;
} else {
$uid = $sql->fetch(PDO::FETCH_LAZY);
return $uid['id'];
}
}
// Узнаем логин по id
function ulogin($str, $connect) {
$sql = $connect->prepare("select * from `users` where `id` = ?");
$sql->execute(array($str));
$num = $sql->rowCount();
if ($num  == 0) {
return false;
} else {
$ulogin = $sql->fetch(PDO::FETCH_LAZY);
return $ulogin['login'];
}
}
if (isset($active) == true) {
// Файлы, загруженные юзерами
$count_files = count(array_filter(glob($_SERVER["DOCUMENT_ROOT"]."/files/*"), 'is_file'));
// Кол-во цепочек писем
$count_mess = $connect->prepare("select `id` from `mail` where `who` = ? group by `user`");
$count_mess->execute(array($user['id']));
$count_mess = $count_mess->rowCount();
// Сообщения
$count_mail = $connect->prepare("select count(`id`) from `mail` where `who` = ? or `user` = ?");
$count_mail->execute(array($user['id'], $user['id']));
$count_mail = $count_mail->fetchColumn();
$c_new_mail = $connect->prepare("select count(`id`) from `mail` where `read` = '0' and `who` = ?");
$c_new_mail->execute(array($user['id']));
$c_new_mail = $c_new_mail->fetchColumn();
$new_mail = ($c_new_mail > 0) ? '<span>+'.$c_new_mail.'</span>' : '';
// Кол-во сообщений чата
$ch = $connect->query("select count(`id`) from `guest`")->fetchColumn();
// Новые сообщения чата
$new_chat = $connect->query("select count(`id`) from `guest` where `date`>'".(time() - 3600 * 12)."'")->fetchColumn();
$c_new_chat = ($new_chat > 0) ? '<span>+'.val($new_chat).'</span>' : '';
// Блог
$count_blog = $connect->query("select count(`id`) from `blog`")->fetchColumn();
$stmt_count_myblog = $connect->prepare("select count(`id`) from `blog` where `uid` = ?");
$stmt_count_myblog->execute(array($user['id']));
$count_myblog = $stmt_count_myblog->fetchColumn();
// Заходило сегодня
$count_day_user = $connect->query("select count(`id`) from `users` where `lasttime`>'".(time() - 3600 * 12)."'")->fetchColumn();
// Кол-во пользователей
$count_users = $connect->query("select count(`id`) from `users`")->fetchColumn();
// Кол-во зарегистрированных пользователей сегодня
$count_users_new = $connect->query("select count(`id`) from `users` where `datereg`>'".mktime(0, 0, 1, date('m'), date('d'), date('Y'))."'")->fetchColumn();
// Кол-во пользователей онлайн
$count_online_user = $connect->query("select count(`id`) from `users` where `lasttime`>'".(time() - 900)."'")->fetchColumn();
}
?>